import App from './App'

// #ifndef VUE3
import Vue from 'vue'
import './uni.promisify.adaptor'
Vue.config.productionTip = false
App.mpType = 'app'

import config from './config'
import './mixins'
Vue.prototype.config = config

import VueI18n from 'vue-i18n';
import $cn from '@/locales/zh-cn.js';
import $en from '@/locales/en.js'; 

Vue.use(VueI18n);

const i18n = new VueI18n({
	locale: uni.getStorageSync('locale') ? uni.getStorageSync('locale') : 'zh-cn', 
	messages: {
		'zh-cn': $cn,  
		'en': $en 
	}
});

Vue.prototype._i18n = i18n;

import uView from 'dry-uview-ui'
Vue.use(uView)
// 如此配置即可
uni.$u.config.unit = 'rpx'

const app = new Vue({
	i18n,
	...App
})
app.$mount()
// #endif

// #ifdef VUE3
import {
	createSSRApp
} from 'vue'
export function createApp() {
	const app = createSSRApp(App)
	return {
		app
	}
}
// #endif